util: Add maintainer tools to create upstream patches

This changeset adds a maintainer script, create_patches.sh, that can
be used to prepare for upstream from a git repository. The script can
be used to generate patches in Mercurial or git format. The commit
messages in the exported patches are all filtered, see
upstream_msg_filter.sed, to ensure that irrelevant meta data isn't
included in the upstream commit.

Kudos to Curtis Dunham and Nikos Nikoleris for reviews and usability
enhancements for earlier versions of this patch.

Change-Id: Ia4cd089a32834b5e046ef58c0a173ca285b77bca
Signed-off-by: Andreas Sandberg <andreas.sandberg@arm.com>
Reviewed-by: Curtis Dunham <curtis.dunham@arm.com>
Reviewed-by: Nikos Nikoleris <nikos.nikoleris@arm.com>
Reviewed-by: Jason Lowe-Power <jason@lowepower.com>
This commit is contained in:
Andreas Sandberg 2017-01-03 11:31:46 +00:00
parent 6a49dee3f3
commit f835378bea
3 changed files with 360 additions and 0 deletions

177
util/maint/create_patches.sh Executable file
View File

@ -0,0 +1,177 @@
#!/bin/bash
#
# Copyright (c) 2016 ARM Limited
# All rights reserved
#
# The license below extends only to copyright in the software and shall
# not be construed as granting a license to any other intellectual
# property including but not limited to intellectual property relating
# to a hardware implementation of the functionality of the software
# licensed hereunder. You may use the software subject to the license
# terms below provided that you ensure that this notice is replicated
# unmodified and in its entirety in all distributions of the software,
# modified or unmodified, in source code or in binary form.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are
# met: redistributions of source code must retain the above copyright
# notice, this list of conditions and the following disclaimer;
# redistributions in binary form must reproduce the above copyright
# notice, this list of conditions and the following disclaimer in the
# documentation and/or other materials provided with the distribution;
# neither the name of the copyright holders nor the names of its
# contributors may be used to endorse or promote products derived from
# this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#
# Authors: Andreas Sandberg
#
set -e
REL_SCRIPT_DIR=`dirname "$0"`
SCRIPT_NAME=`basename "$0"`
SCRIPT_DIR=$(cd "$REL_SCRIPT_DIR" && echo "$(pwd -P)")
MSG_FILTER="$SCRIPT_DIR"/upstream_msg_filter.sed
CONV_HG="$SCRIPT_DIR"/git-patch-to-hg-patch
PATCH_DIR="./patches/"
UPSTREAM="upstream/master"
PATCH_FORMAT=
usage()
{
cat <<EOF
$SCRIPT_NAME [OPTION]... [BRANCH]
Format a patch series suitable for upstream consumption.
Options:
-u BRANCH Upstream branch
-d DIR Patch directory
-f FMT Patch format (hg or git)
-h Show this help string.
This script creates a series of patches suitable from upstream
consumption from a git branch. By default, the script works on the
currently checked out branch (HEAD). When invoked, the script executes
the following operations in order:
1. Rebase the patches in the current branch onto the upstream
branch.
2. Filter commit messages.
3. Generate a set of patches in git format or Mercurial format.
EOF
}
branch_exists()
{
git rev-parse --verify -q "$1" > /dev/null
}
while getopts ":u:d:f:h" OPT; do
case $OPT in
d)
PATCH_DIR="$OPTARG"
;;
u)
UPSTREAM="$OPTARG"
;;
f)
PATCH_FORMAT="$OPTARG"
;;
h)
usage
exit 0
;;
\?)
echo "$0: invalid option -- '$OPTARG'" >&2
echo "Try '$0 -h' for more information." >&2
exit 1
;;
:)
echo "$0: option requires an argument -- '$OPTARG'" >&2
exit 1
;;
*)
echo "Unhandled getopt return:" >&2
echo "OPT: $OPT" >&2
echo "OPTARG: $OPTARG" >&2
exit 1
esac
done
shift $((OPTIND - 1))
BRANCH="${1:-HEAD}"
case "$PATCH_FORMAT" in
git|hg)
;;
"")
echo "Error: No patch format specified" >&2
exit 1
;;
*)
echo "Error: Illegal patch format specified: '$PATCH_FORMAT'" >&2
exit 1
esac
if ! branch_exists "$BRANCH"; then
echo "Error: Patch branch '$BRANCH' doesn't exist" 1>&2
exit 2
fi
if ! branch_exists "$UPSTREAM"; then
echo "Error: Upstream branch '$UPSTREAM' doesn't exist." 1>&2
exit 2
fi
SHA_PATCHES=`git rev-parse "$BRANCH"`
OLD_BRANCH=`git symbolic-ref --short -q HEAD`
SHA_UPSTREAM=`git rev-parse "$UPSTREAM"`
echo "Upstream branch: $UPSTREAM"
echo "Patch directory: $PATCH_DIR"
echo "Preparing detached head..."
git checkout -q --detach "$SHA_PATCHES"
# Create an exit trap to checkout the old branch when we're done
exit_trap() {
git checkout -q "$OLD_BRANCH"
}
trap exit_trap EXIT
echo "Rebasing onto upstream master..."
git rebase "$UPSTREAM"
echo "Filtering commit messages..."
git filter-branch -f \
--msg-filter "$MSG_FILTER" \
"$SHA_UPSTREAM"..HEAD > /dev/null
echo "Creating patches..."
git format-patch -p -o "$PATCH_DIR" "$UPSTREAM"
if [ "$PATCH_FORMAT" == "hg" ]; then
echo "Converting patches..."
for P in "$PATCH_DIR"/*.patch; do
"$CONV_HG" $P
done
fi

137
util/maint/git-patch-to-hg-patch Executable file
View File

@ -0,0 +1,137 @@
#!/usr/bin/env python
#
# This file originated from the moz-git-tools repo on GitHub
# (https://github.com/mozilla/moz-git-tools), which contains the
# following LICENSE notice:
#
# <quote>
# Except for git-new-workdir, which is covered under GPLv2, the code
# in this repository is placed into the public domain via CC0.
#
# http://creativecommons.org/publicdomain/zero/1.0/legalcode
# </quote>
r"""Git format-patch to hg importable patch.
(Who knew this was so complicated?)
>>> process(StringIO('From 3ce1ccc06 Mon Sep 17 00:00:00 2001\nFrom: fromuser\nSubject: subject\n\nRest of patch.\nMore patch.\n'))
'# HG changeset patch\n# User fromuser\n\nsubject\n\nRest of patch.\nMore patch.\n'
>>> process(StringIO('From: fromuser\nSubject: A very long subject line. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Morbi faucibus, arcu sit amet\n\nRest of patch.\nMore patch.\n'))
'# HG changeset patch\n# User fromuser\n\nA very long subject line. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Morbi faucibus, arcu sit amet\n\nRest of patch.\nMore patch.\n'
>>> process(StringIO('From: f\nSubject: =?UTF-8?q?Bug=20655877=20-=20Dont=20treat=20SVG=20text=20frames=20?= =?UTF-8?q?as=20being=20positioned.=20r=3D=3F?=\n\nPatch.'))
'# HG changeset patch\n# User f\n\nBug 655877 - Dont treat SVG text frames as being positioned. r=?\n\nPatch.'
"""
# Original author: bholley
import sys
import re
import fileinput
import email, email.parser, email.header, email.utils
import math
from cStringIO import StringIO
from itertools import takewhile
def decode_header(hdr_string):
r"""Clean up weird encoding crap.
>>> clean_header('[PATCH] =?UTF-8?q?Bug=20655877=20r=3D=3F?=')
'[PATCH] Bug 655877 r=?'
"""
rv = []
hdr = email.header.Header(hdr_string, maxlinelen=float('inf'))
for (part, encoding) in email.header.decode_header(hdr):
if encoding is None:
rv.append(part)
else:
rv.append(part.decode(encoding).encode('utf-8'))
return ' '.join(rv)
def clean_header(hdr_string):
r"""Transform a header split over many lines into a header split only where
linebreaks are intended. This is important because hg cares about the first
line of the commit message.
Also clean up weird encoding crap.
>>> clean_header('Foo\n bar\n baz')
'Foo bar baz'
>>> clean_header('Foo\n bar\nSpam\nEggs')
'Foo bar\nSpam\nEggs'
"""
lines = []
curline = ''
for line in decode_header(hdr_string).split('\n'):
if not line.startswith(' '):
lines.append(curline)
curline = ''
curline += line
lines.append(curline)
return '\n'.join(lines[1:])
def process(git_patch_file):
parser = email.parser.Parser()
msg = parser.parse(git_patch_file)
from_hdr = clean_header(msg['From'])
commit_title = clean_header(msg['subject'])
if not len(commit_title) or not len(from_hdr):
sys.stderr.write("%s does not look like a valid git patch file, skipping\n"
% git_patch_file.name)
return
parsed_from = email.utils.parseaddr(from_hdr)
nuke_prefix = r"\[PATCH( \d+/\d+)?\] "
match = re.match(nuke_prefix, commit_title)
if match:
commit_title = commit_title[match.end():]
patch_body = msg.get_payload()
# git format-patch wraps the diff (including trailing whitespace):
# ---
# <diff>
# --
# 2.0.3
# This doesn't hurt parsing the diff at all, but the version number is
# nonsense once the git specific items have been stripped
patch_body = re.sub(r'--\s?\n[0-9\.]+\n$', '', patch_body)
return '\n'.join(['# HG changeset patch',
'# User %s <%s>' % parsed_from,
'',
commit_title,
'',
patch_body])
if __name__ == "__main__":
if len(sys.argv) > 1 and sys.argv[1] == '--test':
import doctest
doctest.testmod()
sys.exit(0)
# If there were no arguments, do stdin->stdout.
filelist = sys.argv[1:]
if not filelist:
lines = process(sys.stdin)
sys.stdout.writelines(lines)
sys.exit(0)
# Otherwise, we take a list of files.
for filename in filelist:
# Read the lines.
f = open(filename, 'r')
lines = process(f)
f.close()
# Process.
if lines:
# Write them back to the same file.
f = open(filename, 'w')
f.writelines(lines)
f.close()

View File

@ -0,0 +1,46 @@
#!/bin/sed -f
#
# Copyright (c) 2016 ARM Limited
# All rights reserved
#
# The license below extends only to copyright in the software and shall
# not be construed as granting a license to any other intellectual
# property including but not limited to intellectual property relating
# to a hardware implementation of the functionality of the software
# licensed hereunder. You may use the software subject to the license
# terms below provided that you ensure that this notice is replicated
# unmodified and in its entirety in all distributions of the software,
# modified or unmodified, in source code or in binary form.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are
# met: redistributions of source code must retain the above copyright
# notice, this list of conditions and the following disclaimer;
# redistributions in binary form must reproduce the above copyright
# notice, this list of conditions and the following disclaimer in the
# documentation and/or other materials provided with the distribution;
# neither the name of the copyright holders nor the names of its
# contributors may be used to endorse or promote products derived from
# this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#
# Authors: Andreas Sandberg
# This script removes metadata tags that should be considered internal
# to a specific gerrit instance.
/Reviewed-on:/d;
/Tested-by:/d;
/Copyright-Check:/d;
/Style-Check:/d;